=== debian/changelog ===
sense-emu (1.2-0ubuntu1) impish; urgency=medium

  * Initial Ubuntu release.

 -- Dave Jones <dave.jones@canonical.com>  Fri, 03 Sep 2021 00:36:05 +0100
