=== debian/control ===
Source: sense-emu
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Homepage: http://sense-emu.readthedocs.io/
Section: python
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 imagemagick,
 librsvg2-bin,
 python3-all,
 python3-doc,
 python3-setuptools,
 python3-sphinx,
 python3-sphinx-rtd-theme,
Standards-Version: 4.5.1
Vcs-Git: https://salsa.debian.org/raspi-team/sense-emu.git
Vcs-Browser: https://salsa.debian.org/raspi-team/sense-emu
Rules-Requires-Root: no

Package: python3-sense-emu
Architecture: all
Section: python
Depends:
 ${misc:Depends},
 ${python3:Depends},
 python3-numpy,
 python3-pil,
 python3-pkg-resources,
Recommends: sense-emu-tools
Description: Client library for the Raspberry Pi Sense HAT emulator.
 sense-emu is an emulator of the Raspberry Pi Sense HAT which runs on multiple
 platforms, and provides an emulation of each sensor on the HAT, along with the
 pixel display and the joystick. The API is exactly the same as the official
 API, meaning code developed against the emulator should require no more than
 a one word change to run on the actual HAT.
 .
 This is the Python 3 version of the package. See sense-emu-tools for the
 emulator binary.

Package: python-sense-emu-doc
Architecture: all
Section: doc
Depends: ${sphinxdoc:Depends}, ${misc:Depends}
Description: Documentation for the Raspberry Pi Sense HAT emulator.
 sense-emu is an emulator of the Raspberry Pi Sense HAT which runs on multiple
 platforms, and provides an emulation of each sensor on the HAT, along with the
 pixel display and the joystick. The API is exactly the same as the official
 API, meaning code developed against the emulator should require no more than
 a one word change to run on the actual HAT.
 .
 This is the version independent documentation for the package.

Package: sense-emu-tools
Architecture: all
Section: devel
Depends:
 ${misc:Depends},
 ${python3:Depends},
 python3-sense-emu (>= ${binary:Version}),
 python3-gi,
 python3-gi-cairo,
Recommends: thonny
Description: Emulator for the Raspberry Pi Sense HAT.
 sense-emu is an emulator of the Raspberry Pi Sense HAT which runs on multiple
 platforms, and provides an emulation of each sensor on the HAT, along with the
 pixel display and the joystick. The API is exactly the same as the official
 API, meaning code developed against the emulator should require no more than
 a one word change to run on the actual HAT.
 .
 This is the tools (GUI and command line) for the emulator.
